Index: trunk/NEMO/OPA_SRC/SOL/solisl.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solisl.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/SOL/solisl.F90	(revision 16)
@@ -36,6 +36,5 @@
 
    !! * Shared module variables
-   LOGICAL, PUBLIC ::   &
-      l_isl = .TRUE.          ! 'key_islands' flag
+   LOGICAL, PUBLIC, PARAMETER ::   l_isl = .TRUE.    !: 'key_islands' flag
 
    !! * module variable
@@ -157,58 +156,55 @@
          zwb(jpi,:) = 0.e0
       ENDIF
-# if defined key_mpp
-      ! Mpp: export boundary values to neighboring processors
-      CALL lbc_lnk( zwb, 'G', 1. )
-# endif
+      IF( lk_mpp )   CALL lbc_lnk( zwb, 'G', 1. )
 
 
       ! 1. Initialization for the search of island grid-points
       ! ------------------------------------------------------
-# if defined key_mpp
-
-      ! Mpp : The overlap region are not taken into account
-      ! (islands bondaries are searched over subdomain only)
-      iista =  1   + jpreci
-      iiend = nlci - jpreci
-      ijsta =  1   + jprecj
-      ijend = nlcj - jprecj
-      ijstm1=  1   + jprecj
-      ijenm1= nlcj - jprecj
-      IF( nbondi == -1 .OR. nbondi == 2 ) THEN
+
+      IF( lk_mpp ) THEN
+
+         ! Mpp : The overlap region are not taken into account
+         ! (islands bondaries are searched over subdomain only)
+         iista =  1   + jpreci
+         iiend = nlci - jpreci
+         ijsta =  1   + jprecj
+         ijend = nlcj - jprecj
+         ijstm1=  1   + jprecj
+         ijenm1= nlcj - jprecj
+         IF( nbondi == -1 .OR. nbondi == 2 ) THEN
+            iista  = 1
+         ENDIF
+         IF( nbondi ==  1 .OR. nbondi == 2 ) THEN
+            iiend  = nlci
+         ENDIF
+         IF( nbondj == -1 .OR. nbondj == 2 ) THEN
+            ijsta  = 1
+            ijstm1 = 2
+         ENDIF
+         IF( nbondj ==  1 .OR. nbondj == 2 ) THEN
+            ijend  = nlcj
+            ijenm1 = nlcj-1
+         ENDIF
+         IF( npolj == 3 .OR. npolj == 4 ) THEN
+            ijend  = nlcj-2
+            ijenm1 = nlcj-2
+         ENDIF 
+      ELSE
+         ! mono- or macro-tasking environnement: full domain scan
          iista  = 1
-      ENDIF
-      IF( nbondi ==  1 .OR. nbondi == 2 ) THEN
-         iiend  = nlci
-      ENDIF
-      IF( nbondj == -1 .OR. nbondj == 2 ) THEN
+         iiend  = jpi
          ijsta  = 1
          ijstm1 = 2
-      ENDIF
-      IF( nbondj ==  1 .OR. nbondj == 2 ) THEN
-         ijend  = nlcj
-         ijenm1 = nlcj-1
-      ENDIF
-      IF( npolj == 3 .OR. npolj == 4 ) THEN
-         ijend  = nlcj-2
-         ijenm1 = nlcj-2
-      ENDIF 
-# else
-
-      ! mono- or macro-tasking environnement: full domain scan
-      iista  = 1
-      iiend  = jpi
-      ijsta  = 1
-      ijstm1 = 2
-      IF( nperio == 3 .OR. nperio == 4 ) THEN
-         ijend  = jpj-2
-         ijenm1 = jpj-2
-      ELSEIF( nperio == 5 .OR. nperio == 6 ) THEN
-         ijend  = jpj-1
-         ijenm1 = jpj-1
-      ELSE
-         ijend  = jpj
-         ijenm1 = jpj-1
-      ENDIF
-# endif
+         IF( nperio == 3 .OR. nperio == 4 ) THEN
+            ijend  = jpj-2
+            ijenm1 = jpj-2
+         ELSEIF( nperio == 5 .OR. nperio == 6 ) THEN
+            ijend  = jpj-1
+            ijenm1 = jpj-1
+         ELSE
+            ijend  = jpj
+            ijenm1 = jpj-1
+         ENDIF
+      ENDIF
 
 
@@ -247,7 +243,6 @@
             inilt = inilt + indil(jj)
          END DO
-# if defined key_mpp
-         CALL mpp_sum( inilt )
-# endif
+         IF( lk_mpp )   CALL mpp_sum( inilt )   ! sum over the global domain
+
          IF( inilt == 0 ) THEN
             IF(lwp) THEN
@@ -255,5 +250,5 @@
                WRITE(numout,*) ' change parameter.h'
             ENDIF
-            STOP 'isldom'
+            STOP 'isldom'      !cr replace by nstop
          ENDIF
          
@@ -381,7 +376,5 @@
          ! Take account of redundant points
          
-# if defined key_mpp
-         CALL mpp_sum( ip )
-# endif
+         IF( lk_mpp )   CALL mpp_sum( ip )   ! sum over the global domain
          
          IF( ip > jpnisl ) THEN
@@ -391,5 +384,5 @@
                WRITE(numout,*) ' change parameter.h'
             ENDIF
-            STOP 'isldom'
+            STOP 'isldom'    !cr => nstop
          ENDIF
          
@@ -409,7 +402,5 @@
 
       inilt = isrchne( jpij, zwb(1,1), 1, 0. )
-# if defined key_mpp
-      CALL mpp_min( inilt )
-# endif
+      IF( lk_mpp )   CALL mpp_min( inilt )   ! min over the global domain
 
       IF( inilt /= jpij+1 ) THEN
@@ -426,5 +417,5 @@
       ! ----------------------------------------
 
-      CALL islpri
+      CALL isl_pri
 
 
@@ -432,5 +423,5 @@
       ! -------------------------------------------------------
 
-      CALL islpth
+      CALL isl_pth
 
    END SUBROUTINE isl_dom
@@ -466,11 +457,11 @@
          ipe = mnisl(3,jni)
          ipw = mnisl(4,jni)
-# if defined key_mpp
-         CALL mpp_sum( ip  )
-         CALL mpp_sum( ipn )
-         CALL mpp_sum( ips )
-         CALL mpp_sum( ipe )
-         CALL mpp_sum( ipw )
-# endif
+         IF( lk_mpp ) THEN
+            CALL mpp_sum( ip  )   ! sums over the global domain
+            CALL mpp_sum( ipn )
+            CALL mpp_sum( ips )
+            CALL mpp_sum( ipe )
+            CALL mpp_sum( ipw )
+         ENDIF
          IF(lwp) THEN
             WRITE(numout,9000) jni
@@ -484,6 +475,5 @@
       END DO
 
-      ! FORMAT 
-
+      ! FORMAT   !!cr => no more format
  9000 FORMAT(/, /, 'island number= ', i2 )
  9010 FORMAT(/, 'npil=',i4,' npn=',i3,' nps=',i3,' npe=',i3,' npw=',i3 )
@@ -514,6 +504,6 @@
       !!----------------------------------------------------------------------
       !! * Local declarations
-      INTEGER ::   ji, jj, jni, jii, jnp    ! dummy loop indices
-      INTEGER ::   ii, ij                   ! temporary integers
+      INTEGER ::   jni, jii, jnp    ! dummy loop indices
+      INTEGER ::   ii, ij           ! temporary integers
       !!----------------------------------------------------------------------
       
@@ -587,7 +577,5 @@
       REAL(wp), DIMENSION(jpi,jpj) ::   zlamt, zphit
       REAL(wp), DIMENSION(jpi,jpj,2) ::   zwx
-# if defined key_mpp
       REAL(wp), DIMENSION(jpisl*jpisl) ::   ztab
-# endif
       !!----------------------------------------------------------------------
 
@@ -674,14 +662,13 @@
          
       END DO
-# if defined key_mpp
-      DO jnj=1,jpisl
-         DO jni=1,jpisl
-            ztab(jni+(jnj-1)*jpisl) = aisl(jni,jnj)
-         END DO
-      END DO
-
-      CALL mpp_sum( ztab, jpisl*jpisl )
-!!    CALL mpp_sum( aisl, jpisl*jpisl )
-# endif
+      IF( lk_mpp ) THEN
+         DO jnj = 1, jpisl
+            DO jni = 1, jpisl
+               ztab(jni+(jnj-1)*jpisl) = aisl(jni,jnj)
+            END DO
+         END DO
+         CALL mpp_sum( ztab, jpisl*jpisl )   ! sum over the global domain
+!!       CALL mpp_sum( aisl, jpisl*jpisl )
+      ENDIF
 
       ! 1.3 Control print
@@ -775,7 +762,6 @@
       REAL(wp) ::   zep(jpisl), zlamt(jpi,jpj), zphit(jpi,jpj), zdept(1), zprec(4)
       REAL(wp) ::   zdate0, zdt
-# if defined key_mpp
+      REAL(wp) ::   t2p1(jpi,1,1)
       INTEGER  ::   iloc
-# endif
       !!----------------------------------------------------------------------
 
@@ -907,79 +893,78 @@
          ! Right hand side of the streamfunction equation
          
-# if defined key_mpp
-
-         ! north fold treatment
-         IF( npolj == 3 .OR. npolj == 5)   iloc=jpiglo-(nimpp-1+nimppt(nono+1)-1)
-         IF( npolj == 4 .OR. npolj == 6)   iloc=jpiglo-2*(nimpp-1)
-         t2p1(:,1,1) = 0.e0
-         ! north and south grid-points
-         DO jii = 1, 2
-            DO jnp = 1, mnisl(jii,jni)
-               ii = miisl(jnp,jii,jni)
-               ij = mjisl(jnp,jii,jni)
-               IF( ( npolj == 3 .OR. npolj == 4 ) .AND.   &
-                  ( ij == nlcj-1 .AND. jii == 1) ) THEN 
-                  iju=iloc-ii+1
-                  t2p1(iju,1,1) =  t2p1(iju,1,1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
-               ELSEIF( ( npolj == 5 .OR. npolj == 6 ) .AND.   &
-                  ( ij == nlcj-1 .AND. jii == 1) ) THEN 
-                  iju=iloc-ii
-                  gcb(ii,ij) =  gcb(ii,ij) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
-                  t2p1(iju,1,1) =  t2p1(iju,1,1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
-               ELSE  
-                  gcb(ii,ij-jii+1) =  gcb(ii,ij-jii+1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
-               ENDIF
-            END DO
-         END DO
-         
-         ! east and west grid-points
-         
-         DO jii = 3, 4
-            DO jnp = 1, mnisl(jii,jni)
-               ii = miisl(jnp,jii,jni)
-               ij = mjisl(jnp,jii,jni)
-               gcb(ii-jii+3,ij) = gcb(ii-jii+3,ij) + hvr(ii,ij) * e2v(ii,ij) / e1v(ii,ij)
-            END DO
-         END DO
-         CALL mpplnks( gcb )
-
-# else
-
-         ! north and south grid-points
-         DO jii = 1, 2
-            DO jnp = 1, mnisl(jii,jni)
-               ii = miisl(jnp,jii,jni)
-               ij = mjisl(jnp,jii,jni)
-               IF( ( nperio == 3 .OR. nperio == 4 ) .AND.   &
-                  ( ij == jpj-1 .AND. jii == 1) ) THEN 
-                  gcb(jpi-ii+1,ij-1) = gcb(jpi-ii+1,ij-1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
-               ELSEIF( ( nperio == 5 .OR. nperio == 6 ) .AND.   &
-                  ( ij == jpj-1 .AND. jii == 1) ) THEN 
-                  gcb(ii,ij) =  gcb(ii,ij) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij)
-                  gcb(jpi-ii,ij) = gcb(jpi-ii,ij) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
-               ELSE  
-                  gcb(ii,ij-jii+1) =  gcb(ii,ij-jii+1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij)
-               ENDIF
-            END DO
-         END DO
-
-         ! east and west grid-points
-         DO jii = 3, 4
-            DO jnp = 1, mnisl(jii,jni)
-               ii = miisl(jnp,jii,jni)
-               ij = mjisl(jnp,jii,jni)
-               IF( bmask(ii-jii+3,ij) /= 0. ) THEN
+         IF( lk_mpp ) THEN
+
+            ! north fold treatment
+            IF( npolj == 3 .OR. npolj == 5)   iloc=jpiglo-(nimpp-1+nimppt(nono+1)-1)
+            IF( npolj == 4 .OR. npolj == 6)   iloc=jpiglo-2*(nimpp-1)
+            t2p1(:,1,1) = 0.e0
+            ! north and south grid-points
+            DO jii = 1, 2
+               DO jnp = 1, mnisl(jii,jni)
+                  ii = miisl(jnp,jii,jni)
+                  ij = mjisl(jnp,jii,jni)
+                  IF( ( npolj == 3 .OR. npolj == 4 ) .AND.   &
+                     ( ij == nlcj-1 .AND. jii == 1) ) THEN 
+                     iju=iloc-ii+1
+                     t2p1(iju,1,1) =  t2p1(iju,1,1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
+                  ELSEIF( ( npolj == 5 .OR. npolj == 6 ) .AND.   &
+                     ( ij == nlcj-1 .AND. jii == 1) ) THEN 
+                     iju=iloc-ii
+                     gcb(ii,ij) =  gcb(ii,ij) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
+                     t2p1(iju,1,1) =  t2p1(iju,1,1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
+                  ELSE  
+                     gcb(ii,ij-jii+1) =  gcb(ii,ij-jii+1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
+                  ENDIF
+               END DO
+            END DO
+         
+            ! east and west grid-points
+         
+            DO jii = 3, 4
+               DO jnp = 1, mnisl(jii,jni)
+                  ii = miisl(jnp,jii,jni)
+                  ij = mjisl(jnp,jii,jni)
                   gcb(ii-jii+3,ij) = gcb(ii-jii+3,ij) + hvr(ii,ij) * e2v(ii,ij) / e1v(ii,ij)
-               ELSE
-
-                  ! east-west cyclic boundary conditions
-                  IF( ii-jii+3 == 1 ) THEN
-                     gcb(jpim1,ij) = gcb(jpim1,ij) + hvr(ii,ij) * e2v(ii,ij) / e1v(ii,ij)
+               END DO
+            END DO
+
+            IF( lk_mpp )   CALL mpplnks( gcb )   !!bug ? should use an lbclnk ? is it possible?
+
+         ELSE
+
+            ! north and south grid-points
+            DO jii = 1, 2
+               DO jnp = 1, mnisl(jii,jni)
+                  ii = miisl(jnp,jii,jni)
+                  ij = mjisl(jnp,jii,jni)
+                  IF( ( nperio == 3 .OR. nperio == 4 ) .AND.   &
+                     ( ij == jpj-1 .AND. jii == 1) ) THEN 
+                     gcb(jpi-ii+1,ij-1) = gcb(jpi-ii+1,ij-1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
+                  ELSEIF( ( nperio == 5 .OR. nperio == 6 ) .AND.   &
+                     ( ij == jpj-1 .AND. jii == 1) ) THEN 
+                     gcb(ii,ij) =  gcb(ii,ij) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij)
+                     gcb(jpi-ii,ij) = gcb(jpi-ii,ij) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
+                  ELSE  
+                     gcb(ii,ij-jii+1) =  gcb(ii,ij-jii+1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij)
                   ENDIF
-               ENDIF
-            END DO
-         END DO
-
-# endif
+               END DO
+            END DO
+
+            ! east and west grid-points
+            DO jii = 3, 4
+               DO jnp = 1, mnisl(jii,jni)
+                  ii = miisl(jnp,jii,jni)
+                  ij = mjisl(jnp,jii,jni)
+                  IF( bmask(ii-jii+3,ij) /= 0. ) THEN
+                     gcb(ii-jii+3,ij) = gcb(ii-jii+3,ij) + hvr(ii,ij) * e2v(ii,ij) / e1v(ii,ij)
+                  ELSE
+                     ! east-west cyclic boundary conditions
+                     IF( ii-jii+3 == 1 ) THEN
+                        gcb(jpim1,ij) = gcb(jpim1,ij) + hvr(ii,ij) * e2v(ii,ij) / e1v(ii,ij)
+                     ENDIF
+                  ENDIF
+               END DO
+            END DO
+         ENDIF
 
          ! Preconditioned right hand side and absolute precision
@@ -1011,7 +996,6 @@
                END DO
             END DO
-# if defined key_mpp
-            CALL mpp_sum( rnorme )
-# endif
+            IF( lk_mpp )   CALL mpp_sum( rnorme )   ! sum over the global domain
+
             IF(lwp) WRITE(numout,*) 'rnorme ', rnorme
             epsr = epsisl * epsisl * rnorme
@@ -1070,7 +1054,5 @@
             END DO
          ENDIF
-# if defined key_mpp
-         CALL lbc_lnk( bsfisl(:,:,jni), 'G', 1. )
-# endif
+         IF( lk_mpp )   CALL lbc_lnk( bsfisl(:,:,jni), 'G', 1. )   ! link at G-point
 
 
@@ -1212,8 +1194,6 @@
          END DO
       END DO
-#   if defined key_mpp
-      !  Mpp : global sum to obtain global dot from local ones
-      CALL mpp_sum( bisl, jpisl )
-#   endif
+      IF( lk_mpp )   CALL mpp_sum( bisl, jpisl )   ! sum over the global domain
+
       DO jni = 1, jpisl                     ! Island stream function trend
          visl(jni) = 0.e0
@@ -1270,7 +1250,6 @@
             zfact = 1.e-6 * bsfn(miisl(1,0,jni),mjisl(1,0,jni))
          ENDIF
-#      if defined key_mpp
-         CALL mpp_isl( zfact )
-#      endif
+         IF( lk_mpp )   CALL mpp_isl( zfact )
+
          IF(lwp) WRITE(numisp,9300) kt, jni, zfact, visl(jni)
          IF( MOD( kt, nwrite ) == 0 .OR. kindic < 0     &
@@ -1293,5 +1272,5 @@
    !!   Default option                                         Empty module
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC ::   l_isl = .FALSE.    ! 'key_islands' flag
+   LOGICAL, PUBLIC, PARAMETER ::   l_isl = .FALSE.    !: 'key_islands' flag
 CONTAINS
    SUBROUTINE isl_dom                        ! Empty routine
@@ -1304,5 +1283,5 @@
    END SUBROUTINE isl_dyn_spg
    SUBROUTINE isl_stp_ctl( kt, kindic )      ! Empty routine
-      WRITE(*,*) kt, kindic                     ! no compilation warning
+      WRITE(*,*) 'isl_stp_ctl: You should not have seen this print! error?', kt, kindic
    END SUBROUTINE isl_stp_ctl
 #endif
Index: trunk/NEMO/OPA_SRC/SOL/solisl_fdir.h90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solisl_fdir.h90	(revision 15)
+++ trunk/NEMO/OPA_SRC/SOL/solisl_fdir.h90	(revision 16)
@@ -109,10 +109,7 @@
 
       END DO
-#   if defined key_mpp
-      CALL mpp_sum( aisl, jpisl*jpisl )
-#   endif
+      IF( lk_mpp )   CALL mpp_sum( aisl, jpisl*jpisl )   ! sum over the global domain
 
       ! 1.3 Control print
-      
       IF(lwp) THEN
          WRITE(numout,*)
@@ -296,67 +293,65 @@
          ! 1.2 Right hand side of the stream FUNCTION equation
          
-#    if defined key_mpp
-         
-         ! north fold treatment
-         IF( npolj == 3 ) iloc = jpiglo -(nimpp-1+nimppt(nono+1)-1)
-         IF( npolj == 4 ) iloc = jpiglo - 2*(nimpp-1)
-         t2p1(:,1,1) = 0.
-         ! north and south grid-points
-         DO jii = 1, 2
-            DO jnp = 1, mnisl(jii,jni)
-               ii = miisl(jnp,jii,jni)
-               ij = mjisl(jnp,jii,jni)
-               IF( ( npolj == 3 .OR. npolj == 4 ) .AND. ( ij == nlcj-1 .AND. jii == 1) ) THEN 
-                  iju=iloc-ii+1
-                  t2p1(iju,1,1) =  t2p1(iju,1,1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
-               ELSE  
-                  gcb(ii,ij-jii+1) =  gcb(ii,ij-jii+1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
-               ENDIF
-            END DO
-         END DO
-         
-         ! east and west grid-points
-
-         DO jii = 3, 4
-            DO jnp = 1, mnisl(jii,jni)
-               ii = miisl(jnp,jii,jni)
-               ij = mjisl(jnp,jii,jni)
-               gcb(ii-jii+3,ij) = gcb(ii-jii+3,ij) + hvr(ii,ij) * e2v(ii,ij) / e1v(ii,ij)
-            END DO
-         END DO
-         CALL mpplnks( gcb )
-        
-#      else
-
-         ! north and south grid-points
-         DO jii = 1, 2
-            DO jnp = 1, mnisl(jii,jni)
-               ii = miisl(jnp,jii,jni)
-               ij = mjisl(jnp,jii,jni)
-               IF( ( nperio == 3 .OR. nperio == 4 ) .AND. ( ij == jpj-1 .AND. jii == 1) ) THEN 
-                  gcb(jpi-ii+1,ij-1) = gcb(jpi-ii+1,ij-1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
-               ELSE  
-                  gcb(ii,ij-jii+1) =  gcb(ii,ij-jii+1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij)
-               ENDIF
-            END DO
-         END DO
-
-         ! east and west grid-points
-         DO jii = 3, 4
-            DO jnp = 1, mnisl(jii,jni)
-               ii = miisl(jnp,jii,jni)
-               ij = mjisl(jnp,jii,jni)
-               IF( bmask(ii-jii+3,ij) /= 0. ) THEN
+         IF( lk_mpp ) THEN
+            ! north fold treatment
+            IF( npolj == 3 ) iloc = jpiglo -(nimpp-1+nimppt(nono+1)-1)
+            IF( npolj == 4 ) iloc = jpiglo - 2*(nimpp-1)
+            t2p1(:,1,1) = 0.
+            ! north and south grid-points
+            DO jii = 1, 2
+               DO jnp = 1, mnisl(jii,jni)
+                  ii = miisl(jnp,jii,jni)
+                  ij = mjisl(jnp,jii,jni)
+                  IF( ( npolj == 3 .OR. npolj == 4 ) .AND. ( ij == nlcj-1 .AND. jii == 1) ) THEN 
+                     iju=iloc-ii+1
+                     t2p1(iju,1,1) =  t2p1(iju,1,1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
+                  ELSE  
+                     gcb(ii,ij-jii+1) =  gcb(ii,ij-jii+1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
+                  ENDIF
+               END DO
+            END DO
+         
+            ! east and west grid-points
+
+            DO jii = 3, 4
+               DO jnp = 1, mnisl(jii,jni)
+                  ii = miisl(jnp,jii,jni)
+                  ij = mjisl(jnp,jii,jni)
                   gcb(ii-jii+3,ij) = gcb(ii-jii+3,ij) + hvr(ii,ij) * e2v(ii,ij) / e1v(ii,ij)
-               ELSE
-                  ! east-west cyclic boundary conditions
-                  IF( ii-jii+3 == 1 ) THEN
-                     gcb(jpim1,ij) = gcb(jpim1,ij) + hvr(ii,ij) * e2v(ii,ij) / e1v(ii,ij)
+               END DO
+            END DO
+
+            IF( lk_mpp )   CALL mpplnks( gcb )   !!bug ? should use an lbclnk ? is it possible???
+
+         ELSE
+            ! north and south grid-points
+            DO jii = 1, 2
+               DO jnp = 1, mnisl(jii,jni)
+                  ii = miisl(jnp,jii,jni)
+                  ij = mjisl(jnp,jii,jni)
+                  IF( ( nperio == 3 .OR. nperio == 4 ) .AND. ( ij == jpj-1 .AND. jii == 1) ) THEN 
+                     gcb(jpi-ii+1,ij-1) = gcb(jpi-ii+1,ij-1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij) 
+                  ELSE  
+                     gcb(ii,ij-jii+1) =  gcb(ii,ij-jii+1) + hur(ii,ij) * e1u(ii,ij) / e2u(ii,ij)
                   ENDIF
-               ENDIF
-            END DO
-         END DO
-        
-#    endif
+               END DO
+            END DO
+
+            ! east and west grid-points
+            DO jii = 3, 4
+               DO jnp = 1, mnisl(jii,jni)
+                  ii = miisl(jnp,jii,jni)
+                  ij = mjisl(jnp,jii,jni)
+                  IF( bmask(ii-jii+3,ij) /= 0. ) THEN
+                     gcb(ii-jii+3,ij) = gcb(ii-jii+3,ij) + hvr(ii,ij) * e2v(ii,ij) / e1v(ii,ij)
+                  ELSE
+                     ! east-west cyclic boundary conditions
+                     IF( ii-jii+3 == 1 ) THEN
+                        gcb(jpim1,ij) = gcb(jpim1,ij) + hvr(ii,ij) * e2v(ii,ij) / e1v(ii,ij)
+                     ENDIF
+                  ENDIF
+               END DO
+            END DO
+         ENDIF
 
          ! 1.4 Preconditioned right hand side and absolute precision
@@ -388,7 +383,6 @@
                END DO
             END DO
-#if defined key_mpp
-            CALL mpp_sum( rnorme )
-#endif
+            IF( lk_mpp )   CALL mpp_sum( rnorme )   ! sum over the global domain
+
             IF(lwp) WRITE(numout,*) 'rnorme ', rnorme
             epsr = epsisl * epsisl * rnorme
@@ -451,7 +445,5 @@
             END DO
          ENDIF
-#if defined key_mpp
-         CALL lbc_lnk( bsfisl(:,:,jni), 'G', 1. )
-#endif
+         IF( lk_mpp )   CALL lbc_lnk( bsfisl(:,:,jni), 'G', 1. )   ! link at G-point
          
          
Index: trunk/NEMO/OPA_SRC/SOL/solmat.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SOL/solmat.F90	(revision 15)
+++ trunk/NEMO/OPA_SRC/SOL/solmat.F90	(revision 16)
@@ -18,4 +18,6 @@
    USE obc_oce         ! ocean open boundary conditions
    USE lib_mpp         ! distributed memory computing
+   USE dynspg_rl
+   USE dynspg_fsc
 
    IMPLICIT NONE
@@ -38,8 +40,8 @@
       !!
       !! ** Method  :   The matrix depends on the type of free surface:
-      !!       * default option: rigid lid and bsf
+      !!       * lk_dynspg_rl=T: rigid lid formulation
       !!      The matrix is built for the barotropic stream function system.
       !!      a diagonal preconditioning matrix is also defined.
-      !!       * 'key_dynspg_fsc' defined: free surface
+      !!       * lk_dynspg_fsc=T: free surface formulation
       !!      The matrix is built for the divergence of the transport system
       !!      a diagonal preconditioning matrix is also defined.
@@ -67,8 +69,5 @@
       INTEGER ::   ii, ij, iiend, ijend      ! temporary integers
       REAL(wp) ::   zcoefs, zcoefw, zcoefe, zcoefn  ! temporary scalars
-      REAL(wp) ::   z2dt
-#if defined key_dynspg_fsc
-      REAL(wp) ::   zcoef
-#endif
+      REAL(wp) ::   z2dt, zcoef
       !!----------------------------------------------------------------------
 
@@ -83,4 +82,5 @@
       
       ! initialize to zero
+      zcoef = 0.e0
       gcp(:,:,1) = 0.e0
       gcp(:,:,2) = 0.e0
@@ -94,4 +94,5 @@
 
 #if defined key_dynspg_fsc && ! defined key_obc
+!!cr      IF( lk_dynspg_fsc .AND. .NOT.lk_obc ) THEN
 
       ! defined the coefficients for free surface elliptic system
@@ -99,5 +100,5 @@
       DO jj = 2, jpjm1
          DO ji = 2, jpim1
-            zcoef = z2dt * z2dt * g * rnu * bmask(ji,jj)
+            zcoef = z2dt * z2dt * grav * rnu * bmask(ji,jj)
             zcoefs = -zcoef * hv(ji  ,jj-1) * e1v(ji  ,jj-1) / e2v(ji  ,jj-1)    ! south coefficient
             zcoefw = -zcoef * hu(ji-1,jj  ) * e2u(ji-1,jj  ) / e1u(ji-1,jj  )    ! west coefficient
@@ -109,9 +110,10 @@
             gcp(ji,jj,4) = zcoefn
             gcdmat(ji,jj) = e1t(ji,jj) * e2t(ji,jj) * bmask(ji,jj)    &          ! diagonal coefficient
-                          - zcoefs -zcoefw -zcoefe -zcoefn
+               &          - zcoefs -zcoefw -zcoefe -zcoefn
          END DO
       END DO
       
 #  elif defined key_dynspg_fsc && defined key_obc
+!!cr      ELSEIF( lk_dynspg_fsc .AND. lk_obc ) THEN
 
       !   defined gcdmat in the case of open boundaries
@@ -119,5 +121,5 @@
       DO jj = 2, jpjm1
          DO ji = 2, jpim1
-            zcoef = z2dt * z2dt * g * rnu * bmask(ji,jj)
+            zcoef = z2dt * z2dt * grav * rnu * bmask(ji,jj)
             !  south coefficient
             IF( ( lpsouthobc ) .AND. ( jj == njs0p1 ) ) THEN
@@ -159,4 +161,5 @@
 
 #  else
+!!cr      ELSE
 
       !   defined the coefficients for bsf elliptic system
@@ -173,8 +176,8 @@
             gcp(ji,jj,4) = zcoefn
             gcdmat(ji,jj) = -zcoefs -zcoefw -zcoefe -zcoefn                             ! diagonal coefficient
-            
          END DO
       END DO
       
+!!cr  ENDIF
 #endif
 
@@ -194,4 +197,5 @@
       ! account for the existence of the south symmetric bassin.
       
+!!cr      IF( .NOT.lk_dynspg_fsc ) THEN
 #if ! defined key_dynspg_fsc
       IF( nperio == 2 ) THEN
@@ -203,4 +207,5 @@
          END DO
       ENDIF
+!!cr      ENDIF
 #endif
       
@@ -225,4 +230,5 @@
          gcp(:,:,3) = gcp(:,:,3) * gcdprc(:,:)
          gcp(:,:,4) = gcp(:,:,4) * gcdprc(:,:)
+         IF( nsolv == 2 )   gccd(:,:) = sor * gcp(:,:,2)
 
       ELSE
@@ -467,5 +473,5 @@
       nnitot = nni
 
-      CALL mpp_sum(nnitot,1,numit0ete)
+      CALL mpp_sum( nnitot, 1, numit0ete )
       CALL feti_creadr(malxm,malxmax,nxm,npe*npe,maae,'ae')
 
